package cn.iocoder.yudao.module.member.service.money;

import java.math.BigDecimal;
import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.member.controller.admin.money.vo.*;
import cn.iocoder.yudao.module.member.dal.dataobject.money.MoneyDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 金额 Service 接口
 *
 * @author 秦俊旗
 */
public interface MoneyService {

    /**
     * 创建金额
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createMoney(@Valid MoneySaveReqVO createReqVO);

    /**
     * 更新金额
     *
     * @param updateReqVO 更新信息
     */
    void updateMoney(@Valid MoneySaveReqVO updateReqVO);

    /**
     * 删除金额
     *
     * @param id 编号
     */
    void deleteMoney(Long id);

    /**
     * 获得金额
     *
     * @param id 编号
     * @return 金额
     */
    MoneyDO getMoney(Long id);

    /**
     * 获得金额分页
     *
     * @param pageReqVO 分页查询
     * @return 金额分页
     */
    PageResult<MoneyDO> getMoneyPage(MoneyPageReqVO pageReqVO);

    /**
     * 获得金额
     *
     * @return 金额
     */
    MoneyDO getMoney(Long userId, Long carteenId);

    BigDecimal getAllMoney(Long userId);

    List<MoneyDO> getAllDebt(Long userId);

    void updateById(MoneyDO moneyDO);

    void insertOne(MoneyDO moneyDO);

    void updateList(List<MoneyDO> moneyDOs);

    void cleanDebt(List<Long> debtId );
}